
unit WorkCom_Type;

interface
uses
  Windows,  SysUtils, Messages,  Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;
const
  dcb_Binary           = $00000001;
  dcb_Parity           = $00000002;
  dcb_OutxCTSFlow      = $00000004;
  dcb_OutxDSRFlow      = $00000008;
  dcb_DTRBit1          = $00000010;
  dcb_DTRBit2          = $00000020;
  dcb_DTRControl       = $00000030;
  dcb_DSRSensitivity   = $00000040;
  dcb_TXContinueOnXoff = $00000080;
  dcb_OutX             = $00000100;
  dcb_InX              = $00000200;
  dcb_ErrorChar        = $00000400;
  dcb_Null             = $00000800;
  dcb_RTSBit1          = $00001000;
  dcb_RTSBit2          = $00002000;
  dcb_RTSControl       = $00003000;
  dcb_AbortOnError     = $00004000;
type
  PInt64 =^int64;

  SLibID = record
    DeviceType : WORD ;
    Version : WORD;
    Serial : DWORD;
    Condition : WORD;
  end;
  pSLibID = ^SLibID;

  SLibModuleRecord  = record
    ModuleType : WORD;
    Flow : array[0..2] of BYTE;
    Term : array[0..2] of BYTE;
    TermConst : array[0..2] of Single;
    PressConst : array[0..2] of Single;
  end;
  pSLibModuleRecord = ^SLibModuleRecord;

  SLibCurrentData = record
    Term  : array[0..5] of Single;
    QV : array[0..5] of Single;
    QM : array[0..5] of Single;
    EV : array[0..5] of Single;
  end;
  pSLibCurrentData = ^SLibCurrentData;

  SLibAccumulatedData = record
    StopTime : array[0..5] of Longword;
    E :  array[0..5] of Int64;
    UV :  array[0..5] of Int64;
    UM :  array[0..5] of Int64;
  end;
  pSLibAccumulatedData = ^SLibAccumulatedData;

  SLibArhiveCount =record
    BeginArhive : Longword;
    pNewHourLog : Longword;
    pNewDayLog : Longword;
  end;
  pSLibArhiveCount = ^SLibArhiveCount;

  SLibErrorRecord = record
    ErrorEvent : BYTE;
    ModuleNomer : BYTE;
    DeviceNomer : BYTE;
    Parametr : BYTE;
    Date : Longword;
  end;
  pSLibErrorRecord = ^SLibErrorRecord;

  SLibEditRecord = record
    ErrorEvent : BYTE;
    ModuleNomer : BYTE;
    DeviceNomer : BYTE;
    Parameter : BYTE;
    Date : Longword;
    LastData : Longint;
    NewData : Longint;
  end;
  pSLibEditRecord = ^SLibEditRecord;

  TX12TimeOut = procedure(); stdcall;
  TX12RetID = procedure(ID : pSLibID); stdcall;
  TX12RetModuleCount = procedure(Count : BYTE ); stdcall;
  TX12RetModuleRecord =  procedure(pModuleRec : pSLibModuleRecord); stdcall;
  TX12RetCurrentData =  procedure(pCurrentData : pSLibCurrentData); stdcall;
  TX12RetAccumulatedData =  procedure(pAccumulatedData : pSLibAccumulatedData); stdcall;
  TX12RetArhives =   procedure(pArhiveCount : pSLibArhiveCount); stdcall;
  TX12RetTime_Hour =  procedure(pArhive : pLongword ;Count : WORD); stdcall;
  TX12RetStop_Hour =  procedure(pArhive : pLongword ;Count : WORD); stdcall;
  TX12RetT_Hour =  procedure(pArhive : pLongint ;Count : WORD); stdcall;
  TX12RetU_Hour =  procedure(pArhive : pInt64 ;Count : WORD); stdcall;
  TX12RetM_Hour =  procedure(pArhive : pInt64 ;Count : WORD); stdcall;
  TX12RetE_Hour =   procedure(pArhive : pInt64 ;Count : WORD); stdcall;
  TX12RetTime_Day =  procedure(pArhive : pLongword ;Count : WORD); stdcall;
  TX12RetStop_Day =  procedure(pArhive : pLongword ;Count : WORD); stdcall;
  TX12RetT_Day =  procedure(pArhive : pLongint ;Count : WORD); stdcall;
  TX12RetU_Day =  procedure(pArhive : pInt64 ;Count : WORD); stdcall;
  TX12RetM_Day =  procedure(pArhive : pInt64 ;Count : WORD); stdcall;
  TX12RetE_Day =  procedure(pArhive : pInt64 ;Count : WORD); stdcall;
  TX12RetError_HDev =  procedure(pErrorHDev : pWORD ;Count : WORD); stdcall;
  TX12RetError_HModule = procedure(pErrorHModule : pWORD ;Count : WORD); stdcall;
  TX12RetError_DataDev = procedure(pErrorDataDev : pSLibErrorRecord  ;Count : WORD); stdcall;
  TX12RetError_DataModule = procedure(pErrorDataDev : pSLibErrorRecord;Count : WORD); stdcall;
  TX12RetEdit_HModule = procedure(pEditHModule : pWORD); stdcall;
  TX12RetEdit_DataModule = procedure(pEditRecord : pSLibEditRecord ;Count : WORD); stdcall;

type
  TSlot = record
    hCom : THandle;
    Address : BYTE;
    WorkType : BYTE;
    Rez1 : BYTE;
    Rez2 : BYTE;
    TimeOut : DWORD;
    pTimeOut : TX12TimeOut;
    pRetID : TX12RetID;
    pRetModuleCount : TX12RetModuleCount;
    pRetModuleRecord : TX12RetModuleRecord;
    pRetCurrentData : TX12RetCurrentData;
    pRetAccumulatedData : TX12RetAccumulatedData;
    pRetArhiveCount : TX12RetArhives;
    pRetTime_Hour : TX12RetTime_Hour;
    pRetStop_Hour : TX12RetStop_Hour;
    pRetT_Hour : TX12RetT_Hour;
    pRetU_Hour : TX12RetU_Hour;
    pRetM_Hour : TX12RetM_Hour;
    pRetE_Hour : TX12RetE_Hour;
    pRetTime_Day : TX12RetTime_Day;
    pRetStop_Day : TX12RetStop_Day;
    pRetT_Day : TX12RetT_Day;
    pRetU_Day : TX12RetU_Day;
    pRetM_Day : TX12RetM_Day;
    pRetE_Day : TX12RetE_Day;
    pRetError_HDev : TX12RetError_HDev;
    pRetError_HModule : TX12RetError_HModule;
    pRetError_DataDev : TX12RetError_DataDev;
    pRetError_DataModule : TX12RetError_DataModule;
    pRetEdit_HModule : TX12RetEdit_HModule;
    pRetEdit_DataModule : TX12RetEdit_DataModule;
  end;
  pTSlot = ^TSlot;

function CloseCOMPort(var hCom: THandle): Boolean;
function OpenCOMPort(FDeviceName      : string; BaudRate: Integer): THandle;

implementation

function OpenCOMPort(FDeviceName      : string; BaudRate: Integer): THandle;
var
  CommTimeouts: TCommTimeouts;
  DCB: TDCB;
begin
  Result := CreateFile(pChar('\\.\'+FDeviceName),
GENERIC_READ or GENERIC_WRITE, 0, nil, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL,0);
  if (Result = INVALID_HANDLE_VALUE) or (Result = 0) then
  begin
    Result := 0;
    Exit;
  end;

  FillChar(DCB, Sizeof(DCB), 0);
  if not GetCommState(Result, DCB) then
  begin
    CloseHandle(Result);
    Result := 0;
    Exit;
  end;
  DCB.BaudRate := BaudRate;
  DCB.Flags := dcb_Binary or dcb_DTRBit1 or dcb_RTSBit1;
  DCB.ByteSize := 8;
  DCB.Parity := NOPARITY;
  DCB.StopBits := TWOSTOPBITS;
  if not SetCommState(Result, DCB) then
  begin
    CloseHandle(Result);
    Result := 0;
    Exit;
  end;
  FillChar(CommTimeOuts, SizeOf(TCommTimeouts), 0);
  CommTimeouts.ReadIntervalTimeout := 0;
  CommTimeouts.ReadTotalTimeoutMultiplier := 0;
  CommTimeouts.ReadTotalTimeoutConstant := 10000;
  CommTimeouts.WriteTotalTimeoutMultiplier := 0;
  CommTimeouts.WriteTotalTimeoutConstant := 5000;
  if not SetCommTimeOuts(Result, CommTimeOuts) then
  begin
    CloseHandle(Result);
    Result := 0;
    Exit;
  end;
end;
function CloseCOMPort(var hCom: THandle): Boolean;
begin
  Result := CloseHandle(hCom);
  if Result then
    hCom := 0;
end;
end.
